;; ncadBlockView.lsp
;; ブロックのイメージを作成するために、ncadBlockView.exe から呼ばれる LISP
;; 2024/06/22
;; f.izawa
(defun c:makeBlockItems( / fpath bname)
  (setq fpath (getvar "USERS1"))
  (setq bname (getvar "USERS2")) 
  (setvar "USERI1" 0)
  (listBlockItems fpath bname)
  (setvar "USERI1" 1)
  (princ)
)
;; ブロックの内部図形の情報一覧
;; fpath は最後に "\n\n" を含む
(defun listBlockItems( fpath bname / fname fp ename ent etype lst)
  ; 0,6,8,10,11,40,42,50,51,62,70,90
  ; line
  ; 0,8,10,11,62
  ; circle
  ; 0,8,10,40,62
  ; arc
  ; 0,8,10,40,50,51,62
  ; lwp
  ; 0,8,10,42,62,70,90

  (setq fname (strcat fpath "listBlockItems.txt"))
  (setq fp (open fname "w"))
  (setq ename (tblobjname "BLOCK" bname)) 
  (while ename
    (setq ent (entget ename))
    ;; ARC の最後 51 の数値が欠落するため
    (setq etype (cdr (assoc 0 ent)))
    (if (= "ARC" etype)
      (progn
        (setq lst  (list (assoc 0 ent)(assoc 8 ent)(assoc 10 ent)
                         (assoc 40 ent)(assoc 50 ent)(assoc 51 ent))
        )
        (if (assoc 62 ent)
          (setq lst (append lst (list (assoc 62 ent))))
        )
        (princ lst fp)
      )
      (princ ent fp)
    )
    (princ "\n" fp)
    (setq ename (entnext ename))
  )
  (close fp)
  (princ)
)
; (defun listBlockItems_old( fpath bname / fname fp ename)
;   (setq fname (strcat fpath "listBlockItems.txt"))
;   (setq fp (open fname "w"))
;   (setq ename (tblobjname "BLOCK" bname)) 
;   (while ename
;     (princ (entget ename) fp)
;     (princ "\n" fp)
;     (setq ename (entnext ename))
;   )
;   (close fp)
;   (princ)
; )

;; 画層情報一覧
;; fpath は最後に "\n\n" を含む
(defun listLayers( fpath / fname fp ent)
  (setq fname (strcat fpath "listLayers.txt"))
  (setq fp (open fname "w"))    
  (princ (setq ent (tblnext "LAYER" T)) fp)
  (princ "\n" fp)
  (while ent
    (princ (entget (tblobjname "LAYER" (cdr (assoc 2 ent)))) fp)
    (princ "\n" fp)
    (setq ent  (tblnext "LAYER"))
  )
  (close fp)
  (princ)
)
